//	`XgNXizJ[\Łj

import java.util.Comparator;

public class ArrayLinkedList<E> {

	//--- m[h ---//
	class Node<E> {
		private E data;			// f[^
		private int next;		// Xǧ㑱|C^
		private int dnext;	// t[Xǧ㑱|C^

		//--- datanextݒ ---//
		void set(E data, int next) {
			this.data = data;
			this.next = next;
		}
	}

	private Node<E>[] n;		// Xg{
	private int size;				// Xg̗eʁiőf[^j
	private int max;				// p̖R[h
	private int head;				// 擪m[h
	private int crnt;				// ڃm[h
	private int deleted;		// t[Xg̐擪m[h
	private static final int NULL = -1;	// 㑱m[h͂Ȃ^Xg͖t

	//--- RXgN^ ---//
	public ArrayLinkedList(int capacity) {
		head = crnt = max = deleted = NULL;
		try {
			n = new Node[capacity];
			for (int i = 0; i < capacity; i++)
				n[i] = new Node<E>();
			size = capacity;
		}
		catch (OutOfMemoryError e) {		// z̐Ɏs
			size = 0;
		}
	}

	//--- ɑ}郌R[h̃CfbNX߂ ---//
	private int getInsertIndex() {
		if (deleted == NULL) {					// 폜R[h݂͑Ȃ
			if (max < size)
				return ++max;								// VR[h𗘗p
			else
				return NULL;								// eʃI[o
		} else {
			int rec = deleted;						// t[Xg
			deleted = n[rec].dnext;				// 擪reco
			return rec;
		}
	}

	//--- R[hidxt[Xgɓo^ ---//
	private void deleteIndex(int idx) {
		if (deleted == NULL) {					// 폜R[h݂͑Ȃ
			deleted = idx;								// idxt[Xg
			n[idx].dnext = NULL;					// 擪ɓo^
		} else {
			int rec = deleted;						// idxt[Xg
			deleted = idx;								// 擪ɑ}
			n[rec].dnext = rec;
		}
	}

	//--- m[hT ---//
	public E search(E obj, Comparator<? super E> c) {
		int ptr = head;									// ݑ̃m[h

		while (ptr != NULL) {
			if (c.compare(obj, n[ptr].data) == 0) {
				crnt = ptr;
				return n[ptr].data;					// T
			}
			ptr = n[ptr].next;						// 㑱m[hɒ
		}
		return null;										// Ts
	}

	//--- 擪Ƀm[h} ---//
	public void addFirst(E obj) {
		int ptr = head;									// }O̐擪m[h
		int rec = getInsertIndex();
		if (rec != NULL) {
			head = crnt = rec;						// recR[hɑ}
			n[head].set(obj, ptr);
		}
	}

	//--- Ƀm[h} ---//
	public void addLast(E obj) {
		if (head == NULL)								// Xgł
			addFirst(obj);								// 擪ɑ}
		else {
			int ptr = head;
			while (n[ptr].next != NULL)
				ptr = n[ptr].next;
			int rec = getInsertIndex();
			if (rec != NULL) {						// recR[hɑ}
				n[ptr].next = crnt = rec;
				n[rec].set(obj, NULL);
			}
		}
	}

	//--- 擪m[h폜 ---//
	public void removeFirst() {
		if (head != NULL) {							// XgłȂ
			int ptr = n[head].next;
			deleteIndex(head);
			head = crnt = ptr;
		}
	}

	//--- m[h폜 ---//
	public void removeLast() {
		if (head != NULL) {
			if (n[head].next == NULL)			// m[hł
				removeFirst();							// 擪m[h폜
			else {
				int ptr = head;							// ̃m[h
				int pre = head;							// ̃m[h̐sm[h

				while (n[ptr].next != NULL) {
					pre = ptr;
					ptr = n[ptr].next;
				}
				n[pre].next = NULL;					// pre͍폜̖m[h
				deleteIndex(pre);
				crnt = pre;
			}
		}
	}

	//--- R[hp폜 ---//
	public void remove(int p) {
		if (head != NULL) {
			if (p == head)								// p擪m[hł
				removeFirst();							// 擪m[h폜
			else {
				int ptr = head;

				while (n[ptr].next != p) {
					ptr = n[ptr].next;
					if (ptr == NULL) return;	// p̓Xgɑ݂Ȃ
				}
				n[ptr].next = NULL;
				deleteIndex(ptr);
				n[ptr].next = n[p].next;
				crnt = ptr;
			}
		}
	}

	//--- ڃm[h폜 ---//
	public void removeCurrentNode() {
		remove(crnt);
	}

	//--- Sm[h폜 ---//
	public void clear() {
		while (head != NULL)						// ɂȂ܂
			removeFirst();								// 擪m[h폜
		crnt = NULL;
	}

	//--- ڃm[hɐi߂ ---//
	public boolean next() {
		if (crnt == NULL || n[crnt].next == NULL)
			return false;									// i߂邱Ƃ͂łȂ
		crnt = n[crnt].next;
		return true;
	}

	//--- ڃm[h\ ---//
	public void printCurrentNode() {
		if (crnt == NULL)
			System.out.println("ڃm[h͂܂B");
		else
			System.out.println(n[crnt].data);
	}

	//--- Sm[h\ ---//
	public void dump() {
		int ptr = head;

		while (ptr != NULL) {
			System.out.println(n[ptr].data);
			ptr = n[ptr].next;
		}
	}
}
